/* Name: main.c
 * Project: RC5 IR remote control
 * Author: Leonas (Levas) Vabolis
 * Creation Date: 2009-01-24
 * Copyright: (c) 2009 by Savel (aka Levas). http://www.vabolis.lt , http://www.savel.org
 * License: GNU GPL v2, check includes for more (c) stuff.
 * Hardware: SAVEL ATMEGA16 testing board. 
 */

#define 	F_CPU 12000000	
#include	<avr\io.h>	
#include <stdlib.h>	
#include <avr/interrupt.h>
#include "rc5.h"
#include "rc5-avr.c"
#include "lcd.c"


#define __AVR_ATmega16__ 1

int main(void)
{
char buffer[7];
      // Initialize Hardware

      // Allow any RC5 device address
	rc5_init (RC5_ALL);
	
	lcd_init(LCD_DISP_ON);
	lcd_clrscr();
	lcd_gotoxy(0,1);
	lcd_puts("RC5 Reader");

      // enable all interrupts
      sei();
	  
    for (;;) { 
          // New RC5 frame arrived?
          if (rc5.flip >= 0)
          {
              // Yes:
              // evaluate RC5 data in `rc5' or make a local copy
              // of it for later use
			 cli();
             lcd_gotoxy(0,0);
			 lcd_puts("Cod:");
			 itoa( rc5.code , buffer, 16);
			 lcd_puts(buffer);
			 lcd_puts(" Adr:");
			 itoa( rc5.addr , buffer, 16);
			 lcd_puts(buffer);
			 lcd_puts(" F:");
			 itoa( rc5.flip , buffer, 16);
			 lcd_puts(buffer);
			 lcd_puts("  ");
			 sei();

              // Tell receiver software to get more RC5 frames
              rc5.flip = -1;
          } // done RC5	
		}
    return 0;
}